www/src/Entity/Promotion.php
<?php

namespace App\Entity;

use App\Repository\PromotionRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Serializer\Annotation\Ignore;

#[ORM\Entity(repositoryClass: PromotionRepository::class)]
class Promotion
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    #[Groups(['promotion'])]
    private ?int $id = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    #[Groups(['promotion'])]
    private ?\DateTimeInterface $date_debut = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    #[Groups(['promotion'])]
    private ?\DateTimeInterface $date_fin = null;

    #[ORM\Column(type: Types::DECIMAL, precision: 5, scale: 2)]
    #[Groups(['promotion'])]
    private ?string $pourcentage_remise = null;

    #[ORM\Column(length: 255)]
    #[Groups(['promotion'])]
    private ?string $libelle = null;

    #[ORM\OneToMany(mappedBy: 'promotion', targetEntity: Produit::class)]
    private Collection $produits;

    public function __construct()
    {
        $this->produits = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDateDebut(): ?\DateTimeInterface
    {
        return $this->date_debut;
    }

    public function setDateDebut(\DateTimeInterface $date_debut): self
    {
        $this->date_debut = $date_debut;

        return $this;
    }

    public function getDateFin(): ?\DateTimeInterface
    {
        return $this->date_fin;
    }

    public function setDateFin(\DateTimeInterface $date_fin): self
    {
        $this->date_fin = $date_fin;

        return $this;
    }

    public function getPourcentageRemise(): ?string
    {
        return $this->pourcentage_remise;
    }

    public function setPourcentageRemise(string $pourcentage_remise): self
    {
        $this->pourcentage_remise = $pourcentage_remise;

        return $this;
    }

    public function getLibelle(): ?string
    {
        return $this->libelle;
    }

    public function setLibelle(string $libelle): self
    {
        $this->libelle = $libelle;

        return $this;
    }

    /**
     * @return Collection<int, Produit>
     */
    public function getProduits(): Collection
    {
        return $this->produits;
    }

    public function addProduit(Produit $produit): self
    {
        if (!$this->produits->contains($produit)) {
            $this->produits->add($produit);
            $produit->setPromotion($this);
        }

        return $this;
    }

    public function removeProduit(Produit $produit): self
    {
        if ($this->produits->removeElement($produit)) {
            // set the owning side to null (unless already changed)
            if ($produit->getPromotion() === $this) {
                $produit->setPromotion(null);
            }
        }

        return $this;
    }

    public function __toString(): string
    {
        return $this->libelle;
    }
}

www/src/Controller/PageListController.php
<?php

namespace App\Controller;

use App\Entity\Categorie;
use App\Repository\CategorieRepository;
use App\Repository\ProduitRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Serializer\SerializerInterface;

class PageListController extends AbstractController
{
    #[Route('/', name: 'app_page_list')]
    public function indexAll(ProduitRepository $produitRepository, CategorieRepository $categorieRepository): Response
    {

        $productCollection = $produitRepository->findAll();
        $categoryCollection = $categorieRepository->findAll();

        return $this->render('page_list/index.html.twig', [
            'controller_name' => 'PageListController',
            'page_list_name' => 'Nos Produits',
            'current_category' => null,
            'productCollection' => $productCollection,
            'categoryCollection' => $categoryCollection,
        ]);
    }

    #[Route('/category/{category}', name: 'app_page_list_filtered')]
    public function indexCategory(Categorie $category, ProduitRepository $produitRepository, CategorieRepository $categorieRepository): Response
    {
        $productCollection = $category->getProduits();
        $categoryCollection = $categorieRepository->findAll();
        
        return $this->render('page_list/index.html.twig', [
            'controller_name' => 'PageListController',
            'page_list_name' => $category->getLibelle(),
            'current_category' => $category,
            'productCollection' => $productCollection,
            'categoryCollection' => $categoryCollection,
        ]);
    }
    #[Route('/ajax/category/{category}', name: 'app_page_list_ajax_filtered')]
    public function ajaxCategory(Categorie $category, ProduitRepository $produitRepository, CategorieRepository $categorieRepository, SerializerInterface $serializer): Response
    {
        $productCollection = $category->getProduits();

        $content = [
            'productCollection' => json_decode($serializer->serialize(
                $productCollection,
                'json', ['groups' => ['promotion', 'categorie', 'produit']]
            )),
            'category' => json_decode($serializer->serialize(
                $category,
                'json', ['groups' => ['categorie', 'produit']]
            )),
        ];

        $response = new JsonResponse($content);
        $response->headers->set('Content-Type', 'application/json');
        return $response;
    }
}

www/templates/page_list/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Page List{% endblock %}

{% block body %}
<!-- sidebar + content -->

  <!-- Heading -->
  <div class="bg-primary mb-4">
    <div class="container py-4">
      <h3 class="page-list-name text-white mt-2">{{ page_list_name|e}}</h3>
      <!-- Breadcrumb -->
      <nav class="breadcrumb d-flex mb-2">
        <h6 class="mb-0">
          <a href="/" class="text-white-50">Home</a>
          {% if current_category %}
            <span class="text-white-50 mx-2"> > </span>
            <a href="/category/{{current_category.id|e }}" class="current-category-link text-white"><u>{{current_category.libelle}}</u></a>
          {% endif %}
        </h6>
      </nav>
      <!-- Breadcrumb -->
    </div>
  </div>


<section class="">
  <div class="container">
    <div class="row">
      
      {% block sidebar %}{% include "page_list/sidebar.html.twig" %}{% endblock %}
      
      <!-- content -->
      <div class="col-lg-9">
        <header class="d-sm-flex align-items-center border-bottom mb-4 pb-3">
          <strong class="product-collection-count d-block py-2">{{productCollection|length}} produits trouvés </strong>
        </header>

        <div class="loader">
          <center>
              <img width="50px" style="display:none;" class="loading-image" src="/assets/images/loader.gif" alt="loading..">
          </center>
        </div>

        <div class="product-list">
          {% for product in productCollection %}
            <div class="row justify-content-center mb-3">
                <div class="col-md-12">
                  <div class="card shadow-0 border rounded-3">
                    <div class="card-body">
                      <div class="row g-0">
                        <div class="col-xl-3 col-md-4 d-flex justify-content-center">
                          <div class="bg-image hover-zoom ripple rounded ripple-surface me-md-3 mb-3 mb-md-0">
                            <img src="{{product.image}}" class="w-100" />
                            <a href="#!">
                              <div class="hover-overlay">
                                <div class="mask" style="background-color: rgba(253, 253, 253, 0.15);"></div>
                              </div>
                            </a>
                          </div>
                        </div>
                        <div class="col-xl-6 col-md-5 col-sm-7">
                          <h5>{{ product.libelle|e }}</h5>
                          <p class="text mb-4 mb-md-0">
                          {{ product.description|e }}
                          </p>
                        </div>
                        <div class="col-xl-3 col-md-3 col-sm-5">
                          <div class="d-flex flex-row align-items-center mb-1">
                            <h4 class="mb-1 me-1 {{product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() ? 'text-danger'}}">
                              {% if product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() %}
                                {{product.prix - product.promotion.pourcentageRemise / 100 * product.prix|number_format()}}€
                              {% else %}
                                {{product.prix|e}}€
                              {% endif %}
                            </h4>
                            {% if product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() %}
                              <span>
                                <s>
                                  {{product.prix|e}}€
                                </s>
                              </span>
                            {% endif %}
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
          {% endfor %}
        </div>
      </div>
    </div>
  </div>
</section>
{% endblock %}

www/templates/page_list/product.html.twig
{% block product %}
  <div class="row justify-content-center mb-3">
    <div class="col-md-12">
      <div class="card shadow-0 border rounded-3">
        <div class="card-body">
          <div class="row g-0">
            <div class="col-xl-3 col-md-4 d-flex justify-content-center">
              <div class="bg-image hover-zoom ripple rounded ripple-surface me-md-3 mb-3 mb-md-0">
                <img src="{{product.image}}" class="w-100" />
                <a href="#!">
                  <div class="hover-overlay">
                    <div class="mask" style="background-color: rgba(253, 253, 253, 0.15);"></div>
                  </div>
                </a>
              </div>
            </div>
            <div class="col-xl-6 col-md-5 col-sm-7">
              <h5>{{ product.libelle|e }}</h5>
              <p class="text mb-4 mb-md-0">
              {{ product.description|e }}
              </p>
            </div>
            <div class="col-xl-3 col-md-3 col-sm-5">
              <div class="d-flex flex-row align-items-center mb-1">
                <h4 class="mb-1 me-1 {{product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() ? 'text-danger'}}">
                  {% if product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() %}
                    {{product.prix - product.promotion.pourcentageRemise / 100 * product.prix|number_format()}}€
                  {% else %}
                    {{product.prix|e}}€
                  {% endif %}
                </h4>
                {% if product.promotion and date(product.promotion.dateDebut) < date() and date(product.promotion.dateFin) > date() %}
                  <span>
                    <s>
                      {{product.prix|e}}€
                    </s>
                  </span>
                {% endif %}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

{% endblock %}

www/templates/page_list/sidebar.html.twig
      <!-- sidebar -->
      <div class="col-lg-3">

        <!-- Toggle button -->
        <button
                class="btn btn-outline-secondary mb-3 w-100 d-lg-none"
                type="button"
                data-mdb-toggle="collapse"
                data-mdb-target="#navbarSupportedContent"
                aria-controls="navbarSupportedContent"
                aria-expanded="false"
                aria-label="Toggle navigation"
                >
          <span>Show filter</span>
        </button>
        <!-- Collapsible wrapper -->
        <div class="collapse card d-lg-block mb-5" id="navbarSupportedContent">
          <div class="accordion" id="accordionPanelsStayOpenExample">
            <div class="accordion-item">
              <h2 class="accordion-header" id="headingOne">
                <button
                        class="accordion-button text-dark bg-light"
                        type="button"
                        data-mdb-toggle="collapse"
                        data-mdb-target="#panelsStayOpen-collapseOne"
                        aria-expanded="true"
                        aria-controls="panelsStayOpen-collapseOne"
                        >
                    Categories
                </button>
              </h2>
              <div id="panelsStayOpen-collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne">
                <div class="accordion-body">
                  <ul class="list-unstyled">
                    {% for category in categoryCollection %}
                      <li><a class="category-link" href-ajax="/ajax/category/{{category.id}}" href="/category/{{category.id}}" class="text-dark">{{category.libelle|e}} </a></li>
                    {% endfor %}
                  </ul>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- sidebar -->